import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;


/**
 * This class can be used to test the <code>FileChooser</code> class.
 *
 * @author Michel Deriaz
 */ 
public class TestFileChooser extends MIDlet implements Runnable, ItemCommandListener {
  public static final String NO_FILE = "No file";
  
  Display display;
  Form form;
  StringItem siFilename1, siFilename2, siFilename3, siFilenameCurrent;
  Command cmdBrowse;
  

  
  public TestFileChooser() {
    form = new Form("TestFileChooser");
    cmdBrowse = new Command("Browse", Command.ITEM, 0);
    
    siFilename1 = new StringItem("Filename 1: ", NO_FILE, StringItem.HYPERLINK);
    siFilename1.setDefaultCommand(cmdBrowse);
    siFilename1.setItemCommandListener(this);
    form.append(siFilename1);
    
    siFilename2 = new StringItem("Filename 2: ", NO_FILE, StringItem.HYPERLINK);
    siFilename2.setDefaultCommand(cmdBrowse);
    siFilename2.setItemCommandListener(this);
    form.append(siFilename2);
    
    siFilename3 = new StringItem("Filename 3: ", NO_FILE, StringItem.HYPERLINK);
    siFilename3.setDefaultCommand(cmdBrowse);
    siFilename3.setItemCommandListener(this);
    form.append(siFilename3);
  }  
    
    
  public void commandAction(Command c, Item item) {
    siFilenameCurrent = (StringItem)item;
    Thread runner = new Thread(this);
    runner.start();
  }
  

  public void run() {
    String initFilename = siFilenameCurrent.getText();
    FileChooser fc = null;
    if (initFilename.equals(NO_FILE)) fc = new FileChooser(display, null);
    else fc = new FileChooser(display, initFilename);
    fc.waitUntilFinished();
    if (fc.getState() == FileChooser.CHOOSEN_NULL) siFilenameCurrent.setText(NO_FILE);
    if (fc.getState() == FileChooser.CHOOSEN) siFilenameCurrent.setText(fc.getFilename());
    display.setCurrent(form);
    display.callSerially(new Runnable() {
      public void run() {
        display.setCurrentItem(siFilenameCurrent);
      }
    });
  }


  protected void startApp() {
    display = Display.getDisplay(this);
    display.setCurrent(form);
  }
  
    
  protected void pauseApp () {}


  protected void destroyApp(boolean unconditional) {}
}